Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class ExplicitOuter extends SubComponent with InfoTransform with TypingTransformers with TreeDSL

  This class ...

  This class ...

  Definition Classes
    transform
  Version

    1.0

- CODE
- ExplicitOuterTransformer
- OuterPathTransformer
- Phase
- RemoveBindingsTransformer
- StdPhase
- TypingTransformer

c

scala.tools.nsc.transform.ExplicitOuter

# ExplicitOuterTransformer 

###

#### class ExplicitOuterTransformer extends OuterPathTransformer

The phase performs the following transformations (more or less...):

(1) An class which is not an interface and is not static gets an outer accessor (@see outerDefs). (1a) A class which is not a trait gets an outer field.

(4) A constructor of a non-trait inner class gets an outer parameter.

(5) A reference C.this where C refers to an outer class is replaced by a selection `this.$outer$$C1 ... .$outer$$Cn` (@see outerPath)

(7) A call to a constructor Q.(args) or Q.$init$(args) where Q != this and the constructor belongs to a non-static class is augmented by an outer argument. E.g. Q.(OUTER, args) where OUTER is the qualifier corresponding to the singleton type Q.

(8) A call to a constructor this.(args) in a secondary constructor is augmented to this.(OUTER, args) where OUTER is the last parameter of the secondary constructor.

(9) Remove private modifier from class members M that are accessed from an inner class.

(10) Remove protected modifier from class members M that are accessed without a super qualifier accessed from an inner class or trait.

(11) Remove private and protected modifiers from type symbols

Note: The whole transform is run in phase explicitOuter.next.

TODO: Make this doc reflect what's actually going on. Some of the deviations are motivated by separate compilation (name mangling based on usage is inherently unstable). Now that traits are compiled 1:1 to interfaces, they can have private members, so there's also less need to make trait members non-private (they still may need to be implemented in subclasses, though we could make those protected...).

Self Type
  ExplicitOuterTransformer
Source
  ExplicitOuter.scala

Linear Supertypes
OuterPathTransformer, Global.UnderConstructionTransformer, ExplicitOuter.TypingTransformer, Global.Transformer, Global.Transformer, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ExplicitOuterTransformer
2. OuterPathTransformer
3. UnderConstructionTransformer
4. TypingTransformer
5. Transformer
6. Transformer
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new ExplicitOuterTransformer(unit: Global.CompilationUnit)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ExplicitOuterTransformer to any2stringadd[ExplicitOuterTransformer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ExplicitOuterTransformer, B)
   Implicit
     This member is added by an implicit conversion from ExplicitOuterTransformer to ArrowAssoc[ExplicitOuterTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: ⇒ A): A
   Definition Classes
     TypingTransformer
8.  final def atOwner[A](owner: Global.Symbol)(trans: ⇒ A): A
   Definition Classes
     TypingTransformer → Transformer
9.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
10.  var curTree: Global.Tree
    Attributes
      protected
    Definition Classes
      TypingTransformer
11.  def currentClass: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
12.  def currentMethod: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
13.  var currentOwner: Global.Symbol
    Attributes
      protected[scala]
    Definition Classes
      Transformer
14.  def ensuring(cond: (ExplicitOuterTransformer) ⇒ Boolean, msg: ⇒ Any): ExplicitOuterTransformer
    Implicit
      This member is added by an implicit conversion from ExplicitOuterTransformer to Ensuring[ExplicitOuterTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (ExplicitOuterTransformer) ⇒ Boolean): ExplicitOuterTransformer
    Implicit
      This member is added by an implicit conversion from ExplicitOuterTransformer to Ensuring[ExplicitOuterTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: ⇒ Any): ExplicitOuterTransformer
    Implicit
      This member is added by an implicit conversion from ExplicitOuterTransformer to Ensuring[ExplicitOuterTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): ExplicitOuterTransformer
    Implicit
      This member is added by an implicit conversion from ExplicitOuterTransformer to Ensuring[ExplicitOuterTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
20.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
21.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ExplicitOuterTransformer to StringFormat[ExplicitOuterTransformer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
23.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
24.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
25.  def isUnderConstruction(clazz: Global.Symbol): Boolean
    Attributes
      protected
    Definition Classes
      UnderConstructionTransformer
26.  var localTyper: (analyzer)#Typer
    Definition Classes
      TypingTransformer
27.  def mixinOuterAccessorDef(mixinClass: Global.Symbol): Global.Tree

    The definition tree of the outer accessor for class mixinClass.

    The definition tree of the outer accessor for class mixinClass.

    mixinClass

      The mixin class which defines the abstract outer accessor which is implemented by the generated one.

28.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
29.  final def notify(): Unit
    Definition Classes
      AnyRef
30.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
31.  def outerAccessorDef: Global.Tree

    The definition tree of the outer accessor of current class

32.  def outerFieldDef: Global.Tree

    The definition tree of the outer accessor of current class

33.  var outerParam: Global.Symbol

    The directly enclosing outer parameter, if we are in a constructor

    The directly enclosing outer parameter, if we are in a constructor

    Attributes
      protected
    Definition Classes
      OuterPathTransformer
34.  def outerPath(base: Global.Tree, from: Global.Symbol, to: Global.Symbol): Global.Tree

    The path

    >     `base'.$outer$$C1 ... .$outer$$Cn

    which refers to the outer instance of class to of value base.

    The path

    >     `base'.$outer$$C1 ... .$outer$$Cn

    which refers to the outer instance of class to of value base. The result is typed but not positioned.

    `base'.$outer$$C1 ... .$outer$$Cn which refers to the outer instance of class to of value base. The result is typed but not positioned.`

    Attributes
      protected
    Definition Classes
      OuterPathTransformer
35.  def outerValue: Global.Tree

    The first outer selection from currently transformed tree.

    The first outer selection from currently transformed tree. The result is typed but not positioned.

    Will return `EmptyTree` if there is no outer accessor because of a premature self reference.

    Attributes
      protected
    Definition Classes
      OuterPathTransformer
36.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
37.  def toString(): String
    Definition Classes
      AnyRef → Any
38.  def transform(tree: Global.Tree): Global.Tree

    The main transformation method

    The main transformation method

    Definition Classes
      ExplicitOuterTransformer → OuterPathTransformer → UnderConstructionTransformer → TypingTransformer → Transformer
39.  def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]
    Definition Classes
      Transformer
40.  def transformIdents(trees: List[Global.Ident]): List[Global.Ident]
    Definition Classes
      Transformer
41.  def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]
    Definition Classes
      Transformer
42.  def transformModifiers(mods: Global.Modifiers): Global.Modifiers
    Definition Classes
      Transformer
43.  def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]
    Definition Classes
      Transformer
44.  def transformTemplate(tree: Global.Template): Global.Template
    Definition Classes
      Transformer
45.  def transformTrees(trees: List[Global.Tree]): List[Global.Tree]
    Definition Classes
      Transformer
46.  def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]
    Definition Classes
      Transformer
47.  def transformUnit(unit: Global.CompilationUnit): Unit

    The transformation method for whole compilation units

    The transformation method for whole compilation units

    Definition Classes
      ExplicitOuterTransformer → Transformer
48.  def transformValDef(tree: Global.ValDef): Global.ValDef
    Definition Classes
      Transformer
49.  def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]
    Definition Classes
      Transformer
50.  def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]
    Definition Classes
      Transformer
51.  val treeCopy: Global.TreeCopier
    Definition Classes
      Transformer
52.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
53.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
54.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
55.  def →[B](y: B): (ExplicitOuterTransformer, B)
    Implicit
      This member is added by an implicit conversion from ExplicitOuterTransformer to ArrowAssoc[ExplicitOuterTransformer] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from OuterPathTransformer

### Inherited from Global.UnderConstructionTransformer

### Inherited from ExplicitOuter.TypingTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ExplicitOuterTransformer to any2stringadd[ExplicitOuterTransformer]

### Inherited by implicit conversion StringFormat from ExplicitOuterTransformer to StringFormat[ExplicitOuterTransformer]

### Inherited by implicit conversion Ensuring from ExplicitOuterTransformer to Ensuring[ExplicitOuterTransformer]

### Inherited by implicit conversion ArrowAssoc from ExplicitOuterTransformer to ArrowAssoc[ExplicitOuterTransformer]

### Ungrouped